#include <stdio.h>

int maxPot(int n, int baza){
int pot = 0;
while(n % baza == 0){
    n/=baza;
    pot++;
}
return pot;
}

int uravnotezen(int n){
    // za drugu grupu: int a= 5; int b=7
    int a = 2;
    int b = 3;
    if( maxPot(n, a) - maxPot(n, b) == 1 || maxPot(n, b) - maxPot(n, a) == 1 ) return 1;
        else return 0;
}

int rekurzija(int n, int najmanji){
    // int n je preostali dio koji trebamo raspisati kao sumu uravnotezenih
    // int najmanji je najmanji broj koji smijemo koristiti u raspisu ostatka kako bi se ocuvala sortiranost
    if(n < 0 ) return 0;
    if(n == 0) {
        return 1;
    }
    int i;
    int sum = 0;
    for(i=najmanji; i<=n; i++){
        if(uravnotezen(i)){
            sum += rekurzija(n-i,i);
        }
    }
    return sum;
}

int main(){

// poziv:
    int n;
    printf("Unesi broj\n");
    scanf("%d", &n);
    printf("Broj nacina na koji se broj %d moze raspisati kao suma uravnotezenih jednak je %d", n , rekurzija(n,1));

}
