#include<stdio.h>
#include<stdlib.h>
#include<string.h>

int provjeriSort(char **p){
    int i;
    if(p[0][0]=='\0') return 0;
    for(i=1;p[i][0]!='\0';i++){
        // za grupu a, tj. uzlazno sortirani niz ide:
        if(strcmp(p[i-1],p[i])>0) return -1;    // za grupu B, tj. za silazno sortirani niz ide: if(strcmp(p[i-1],p[i])<0) return -1;    
    }
    return i;
}

void ubaciString(char **p,char *str){
    int i,j,n;
    n=provjeriSort(p);
    for(i=0;i<n;i++){
        if(strcmp(p[i],str)==0) return; // ako pronadjemo string, ne radimo ništa
        if(strcmp(p[i],str)>0){         // ako string u p[i] postane veci od str, onda str treba ubaciti na mjesto "i" te napraviti return
            for(j=n;j>i;j--){
                p[j]=p[j-1];
            }
            p[i]=str;
            return;
        }
    }
    p[n+1]=p[n];  // ako dosad nismo izasli iz funkcije znaci da str treba dodati na zadnje mjesto u rjecnik
    p[n]=str;
    return;
}

void izbaciString(char **p,char *str){
    int i,j,n;
    n=provjeriSort(p);
    for(i=0;i<n;i++){
        if(strcmp(p[i],str)==0){    // kada ga nadjemo, samo sve ostale stringove pomaknemo za jedno mjesto ulijevo
            for(j=i;j<n;j++){
                p[j]=p[j+1];
            }
            return;
        }
    }
}

char *izmijeniString(char *str,char *staro, char *novo){
    int i;
    char *novistring;

    novistring=(char*)malloc(sizeof(char)); novistring[0]='\0';
    
    for(i=0;i<strlen(str);i++){
        // radimo provjeru slovo po slovo
        if(str[i]!=staro[0]){                           // ako se slovo u "str" i prvo slovo u "staro" razlikuju, kopiramo ga u "novistring"
            int len=strlen(novistring);
            novistring=realloc(novistring,sizeof(char)*(len+2));
            novistring[len]=str[i];
            novistring[len+1]='\0';
        }
        else{
            if(strncmp(str+i,staro,strlen(staro))==0){              // ako se slova podudaraju, ispitujemo nalazi li se "staro" kao substring u str, pocevsi od mjesta i
                novistring=realloc(novistring,sizeof(char)*(strlen(novistring)+strlen(novo)+1));
                strcat(novistring,novo);                            // ako da, kopiramo "novo" u "novistring"
                i+=strlen(staro)-1;                                 // i preskačemo string "staro" u stringu "str"
            }                                              
        }
    }
    return novistring;
}


int main(){
    char **p;
    char *novo="kuca",*staro="zgrada",*str="Moja je zgrada na kraju sela", *pomocni="AAA";
    int i;

    // alokacija memorije za rjecnik p
    p=(char**)malloc(4*sizeof(char*));
    p[0]=(char*)malloc(4*sizeof(char));strcpy(p[0],"AAA");
    p[1]=(char*)malloc(4*sizeof(char));strcpy(p[1],"BBB");
    p[2]=(char*)malloc(4*sizeof(char));strcpy(p[2],"CCC");
    p[3]=(char*)malloc(sizeof(char));p[3][0]='\0';

    printf("ispis rjecnika\n");    
    for(i=0;p[i][0]!='\0';i++) printf("p[%d]=%s\n",i,p[i]);
    printf("provjeriSort(p)=%d\n",provjeriSort(p));

    printf("izbacivanje stringa: %s\n",pomocni);
    izbaciString(p,pomocni);
    for(i=0;p[i][0]!='\0';i++) printf("p[%d]=%s\n",i,p[i]);

    printf("ubacivanje stringa: %s\n",pomocni);
    ubaciString(p,pomocni);
    for(i=0;p[i][0]!='\0';i++) printf("p[%d]=%s\n",i,p[i]);

    printf("izmijeniString(str=%s,staro=%s,novo=%s)=",str,staro,novo);
    printf("%s\n",izmijeniString(str,staro,novo));

    return 0;
}